#!/usr/bin/perl -w  # -*- cperl -*- #
#
#  reboot.pm - Handle the reboot command
#
#  Steve Kemp
#  ---
#  http://www.steve.org.uk/
#
#


#
#  The package this module is implementing.
#
package Xen::Monitor::Plugins::reboot;


#
#  Register the plugin.
#
Xen::Monitor::Server::register_plugin("Xen::Monitor::Plugins::reboot");



#
#  Minimal constructor.
#
sub new { return bless {}; }



#
#  Return the author of this plugin.
#
sub getAuthor
{
    return( 'Steve Kemp <steve@steve.org.uk>' );
}


#
#  Does this plugin require authentication?
#
sub needsAuth
{
    return 1;
}

#
#  Return the commands we handle.
#
sub getCommand
{
    my %commands;
    $commands{"reboot"} = 1;
    return( %commands );
}


#
# Run the command we're sent - this means 'reboot'
#
sub runCommand
{
    my ( $class, $server, $command, @args ) = ( @_ );

    my $host = shift( @args );

    if ( !defined( $host ) )
    {
	print "400 MISSING HOST\r\n";
	return;
    }

    #
    #  Test to see if the user can execute the given command
    #
    if ( ! $server->canControl( $host ) )
    {
	print "400 NOT ALLOWED\r\n";
	return;
    }

	print "200 OK\r\n";

    # Do the reboot.
    my $instance = Xen::Host->new( name => $host );
	$instance->reboot();

	print "300 DONE\r\n";
}


1;
